//
//  Fraction_CalculatorViewController.m
//  Fraction_Calculator
//
//  Created by Mike Ellertson on 9/7/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//
//  --------------------------------------------------------
//  My first updated to test GitHub integration......



#import "Fraction_CalculatorViewController.h"

@implementation Fraction_CalculatorViewController

@synthesize display, displayString;

-(void) dealloc {
    [display release];
    [displayString release];
    [myCalculator release];
    [calcView release];
    [mapView release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // I inserted this override point.  The code in this file wasn't the same as the book.
    firstOperand = YES;
    isNumerator = YES;
    self.displayString = [NSMutableString stringWithCapacity: 40];
    myCalculator = [[Calculator alloc] init];
}


- (void)viewDidUnload
{
    [calcView release];
    calcView = nil;
    [mapView release];
    mapView = nil;
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

-(void) processDigit:(int) digit
{
    currentNumber = currentNumber * 10 + digit;
    [displayString appendString: [NSString stringWithFormat: @"%i", digit]];
    display.text = displayString;
}

-(void) clickDigit: (UIButton *) sender
{
    int digit = sender.tag;
    [self processDigit: digit];
}

-(void) processOp: (char) theOp
{
    NSString *opStr;
    op = theOp;
    switch (theOp) {
            case '+':
                opStr = @" + ";
                break;
            case '-':
                opStr = @" - ";
                break;
            case '*':
                opStr = @" x ";
                break;
            case '/':
                opStr = @" ÷ ";
                break;
    }
    [self storeFracPart];
    firstOperand = NO;
    isNumerator = YES;
    [displayString appendString: opStr];
    display.text = displayString;                       // update the display
}

-(void) storeFracPart
{
    if (firstOperand) {
        if (isNumerator) {
            myCalculator.operand1.numerator = currentNumber;
            myCalculator.operand1.denominator = 1;      // e.g. 3 * 4/5 =
        }
        else
            myCalculator.operand1.denominator = currentNumber;
    }
    else if (isNumerator) {
        myCalculator.operand2.numerator = currentNumber;
        myCalculator.operand2.denominator = 1;          // e.g. 3/2 * 4 =
    }
    else {
        myCalculator.operand2.denominator = currentNumber;
        firstOperand = YES;
    }
    
    currentNumber = 0;
}

-(IBAction) clickOver
{
    [self storeFracPart];
    isNumerator = NO;
    [displayString appendString: @"/"];
    display.text = displayString;
}

// Arithmetic Operation keys
-(IBAction) clickPlus
{
    [self processOp: '+'];
}

-(IBAction) clickMinus
{
    [self processOp: '-'];    
}

-(IBAction) clickMultiply
{
    [self processOp: '*'];
}

-(IBAction) clickDivide
{
    [self processOp: '/'];
}

// Misc. keys
-(IBAction) clickEquals
{
    if (firstOperand == NO) {
        [self storeFracPart];
        [myCalculator performOperation: op];
        
        [displayString appendString: @" = "];
        [displayString appendString: [myCalculator.accumulator convertToString]];
        display.text = displayString;
        
        currentNumber = 0;
        isNumerator = YES;
        firstOperand = YES;
        [displayString setString:@""];
    }
}

-(IBAction) clickClear
{
    isNumerator = YES;
    firstOperand = YES;
    currentNumber = 0;
    [myCalculator clear];
    
    [displayString setString:@""];
    display.text = displayString;
}

-(IBAction) clickMap
{
    // The Map button was clicked.
    calcView.hidden = TRUE;
    mapView.hidden = FALSE;
    
}

@end
